# coding: utf-8

# flake8: noqa

"""
    カラーミーショップ API

    # カラーミーショップ API  [カラーミーショップ](https://shop-pro.jp) APIでは、受注の検索や商品情報の更新を行うことができます。  ## 利用手順  はじめに、カラーミーデベロッパーアカウントを用意します。[デベロッパー登録ページ](https://api.shop-pro.jp/developers/sign_up)から登録してください。  次に、[登録ページ](https://api.shop-pro.jp/oauth/applications/new)からアプリケーション登録を行ってください。 スマートフォンのWebViewを利用する場合は、リダイレクトURLに`urn:ietf:wg:oauth:2.0:oob`を入力してください。  その後、カラーミーショップアカウントの認証ページを開きます。認証ページのURLは、`https://api.shop-pro.jp/oauth/authorize`に必要なパラメータをつけたものです。  |パラメータ名|値| |---|---| |`client_id`|アプリケーション詳細画面で確認できるクライアントID| |`response_type`|\"code\"という文字列| |`scope`| 別表参照| |`redirect_url`|アプリケーション登録時に入力したリダイレクトURL|  `scope`は、以下のうち、アプリケーションが利用したい機能をスペース区切りで指定してください。  |スコープ|機能| |---|---| |`read_products`|商品データの参照| |`write_products`|在庫データの更新| |`read_sales`|受注・顧客データの参照| |`write_sales`|受注データの更新|  以下のようなURLとなります。  ``` https://api.shop-pro.jp/oauth/authorize?client_id=CLIENT_ID&redirect_uri=REDIRECT_URL&response_type=code&scope=read_products%20write_products ```  初めてこのページを訪れる場合は、カラーミーショップアカウントのIDとパスワードの入力を求められます。 承認ボタンを押すと、このアプリケーションがショップのデータにアクセスすることが許可され、リダイレクトURLへリダイレクトされます。  承認された場合は、`code`というクエリパラメータに認可コードが付与されます。承認がキャンセルされた、またはエラーが起きた場合は、 `error`パラメータにエラーの内容を表す文字列が与えられます。  アプリケーション登録時のリダイレクトURLに`urn:ietf:wg:oauth:2.0:oob`を指定した場合は、以下のようなURLにリダイレクトされます。 末尾のパスが認可コードになっています。  ``` https://api.shop-pro.jp/oauth/authorize/AUTH_CODE ```  認可コードの有効期限は発行から10分間です。  最後に、認可コードとアクセストークンを交換します。以下のパラメータを付けて、`https://api.shop-pro.jp/oauth/token`へリクエストを送ります。  |パラメータ名|値| |---|---| |`client_id`|アプリケーション詳細画面に表示されているクライアントID| |`client_secret`|アプリケーション詳細画面に表示されているクライアントシークレット| |`code`|取得した認可コード| |`grant_type`|\"authorization_code\"という文字列| |`redirect_uri`|アプリケーション登録時に入力したリダイレクトURL|  ```console # curl での例  $ curl -X POST \\   -d'client_id=CLIENT_ID' \\   -d'client_secret=CLIENT_SECRET' \\   -d'code=CODE' \\   -d'grant_type=authorization_code'   \\   -d'redirect_uri=REDIRECT_URI'  \\   'https://api.shop-pro.jp/oauth/token' ```  リクエストが成功すると、以下のようなJSONが返ってきます。  ```json {   \"access_token\": \"d461ab8XXXXXXXXXXXXXXXXXXXXXXXXX\",   \"token_type\": \"bearer\",   \"scope\": \"read_products write_products\" } ```  アクセストークンに有効期限はありませんが、許可済みアプリケーション一覧画面から失効させることができます。なお、同じ認可コードをアクセストークンに交換できるのは1度だけです。  取得したアクセストークンは、Authorizationヘッダに入れて使用します。以下にショップ情報を取得する際の例を示します。  ```console # curlの例  $ curl -H 'Authorization: Bearer d461ab8XXXXXXXXXXXXXXXXXXXXXXXXX' https://api.shop-pro.jp/v1/shop.json ```  ## エラー  カラーミーショップAPI v1では  - エラーコード - エラーメッセージ - ステータスコード  の配列でエラーを表現します。以下に例を示します。  ```json {   \"errors\": [     {       \"code\": 404100,       \"message\": \"レコードが見つかりませんでした。\",       \"status\": 404     }   ] } ```   # noqa: E501

    OpenAPI spec version: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

# import apis into sdk package
from colormeshop.api.category_api import CategoryApi
from colormeshop.api.charge_api import ChargeApi
from colormeshop.api.customer_api import CustomerApi
from colormeshop.api.delivery_api import DeliveryApi
from colormeshop.api.etc_api import EtcApi
from colormeshop.api.gift_api import GiftApi
from colormeshop.api.group_api import GroupApi
from colormeshop.api.payment_api import PaymentApi
from colormeshop.api.product_api import ProductApi
from colormeshop.api.sale_api import SaleApi
from colormeshop.api.script_api import ScriptApi
from colormeshop.api.shop_api import ShopApi
from colormeshop.api.stock_api import StockApi

# import ApiClient
from colormeshop.api_client import ApiClient
from colormeshop.configuration import Configuration
# import models into sdk package
from colormeshop.models.application_charge import ApplicationCharge
from colormeshop.models.application_charge_create_response import ApplicationChargeCreateResponse
from colormeshop.models.customer import Customer
from colormeshop.models.delivery import Delivery
from colormeshop.models.delivery_charge_by_prefecture import DeliveryChargeByPrefecture
from colormeshop.models.delivery_date_setting import DeliveryDateSetting
from colormeshop.models.meta import Meta
from colormeshop.models.payment import Payment
from colormeshop.models.product import Product
from colormeshop.models.product_category import ProductCategory
from colormeshop.models.product_group import ProductGroup
from colormeshop.models.product_option import ProductOption
from colormeshop.models.product_pickup import ProductPickup
from colormeshop.models.product_update_request import ProductUpdateRequest
from colormeshop.models.product_variant import ProductVariant
from colormeshop.models.sale import Sale
from colormeshop.models.sale_delivery import SaleDelivery
from colormeshop.models.sale_detail import SaleDetail
from colormeshop.models.script_tag import ScriptTag
from colormeshop.models.shop import Shop
from colormeshop.models.stock import Stock
